#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define L 15

double enterX(void);
double enterEps(void);
int Rekursiiv(double [], int, double, double);
void FailSalvestamine(double [], int);

int main(void){
    double mass[L];
    FailSalvestamine(mass, Rekursiiv(mass, 0, enterX(), enterEps())+1);
    getchar();
    printf("Program is finishing its work...press Enter");
    getchar();
    return 0;
}

double enterX(void){
    double X;
    printf("Enter X ( -1 < X < 1): ");
    do{
        scanf("%lf", &X);
        printf("You've entered %f\n", X);
        if(X>=1||X<=-1){
            printf("Error, entered wrong X, try again! ( -1 < X < 1)\nX: ");
        }
    }while(X>=1||X<=-1);
    return X;
}

double enterEps(void){
    double Eps;
    printf("Enter Eps ( 0 < X < 1): ");
    do{
        scanf("%lf", &Eps);
        printf("You've entered %f\n", Eps);
        if(Eps>=1||Eps<=0){
            printf("Error, entered wrong Eps, try again! ( 0 < Eps < 1)\nEps: ");
        }
    }while(Eps>=1||Eps<=0);
    return Eps;
}

int Rekursiiv(double mass[], int l, double X, double Eps){
    double help, help1;
    mass[l] = pow(-1, l)*(l+1)*pow(X, l);
    help=(pow(-1, l+1)*(l+2)*pow(X, l+1));
    help1=help-mass[l];

    printf("A[%d]=%f\n", l, mass[l]);
     if(((help1>=Eps)||(help1<=Eps*(-1)))&&l<15){
        return Rekursiiv(mass, l+1, X, Eps);
    }
    return l;
}

void FailSalvestamine(double mass[], int MAX){
    int i, check;
    FILE *F1;
    char filename[21];
    printf("Write file F1 filename: ");
    do{
    check=1;
    scanf("%s", filename);
        if((F1=fopen(filename, "w"))==NULL){
            printf("Error file creating, try another name: ");
            check=0;
        }
    }while(check==0);
    fprintf(F1, "Max elements: %d\n", MAX);
     for(i=0; i<MAX; i++){
        fprintf(F1, "A[%d]=%f\n", i, mass[i]);
    }
    fclose(F1);
}
